package com.tzld.piaoquan.ad.engine.commons.base;

import lombok.Data;

@Data
public class AdActionFeature {
    private double adView;
    private double adClick;
    private double adConversion;

    private double ctr;
    private double cvr;

    private double ceilLog(Double key) {
        return Math.ceil(Math.log(key));
    }

    private double bucketRatioFeature(Double key) {
        long bucket = Math.round(Math.log(key * 100));
        if (bucket > 100)
            bucket = 100;
        return (double) bucket;
    }


    public void setAdView(Object key) {
        if (key == null) {
            this.adView = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "-1");
            this.adView = ceilLog(Double.valueOf(formateKey));
        }
    }

    public void setAdClick(Object key) {
        if (key == null) {
            this.adClick = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "-1");
            this.adClick = ceilLog(Double.valueOf(formateKey));
        }
    }

    public void setAdConversion(Object key) {
        if (key == null) {
            this.adConversion = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "-1");
            this.adConversion = ceilLog(Double.valueOf(formateKey));
        }
    }

    public void setCtr(Object key) {
        if (key == null) {
            this.ctr = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "-1");
            this.ctr = bucketRatioFeature(Double.valueOf(formateKey));
        }
    }

    public void setCvr(Object key) {
        if (key == null) {
            this.cvr = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "-1");
            this.cvr = bucketRatioFeature(Double.valueOf(formateKey));
        }
    }


}
