package com.tzld.piaoquan.ad.engine.commons.base;

import lombok.Data;

import java.util.HashMap;
import java.util.Map;

@Data
public class AdItemBytesFeature {

    private final byte[] adId;

    private final byte[] adCode;

    private final byte[] advertiserId;

    private final byte[] advertiserCode;

    private final byte[] campaignId;

    private final byte[] campaignCode;

    private final byte[] creative;

    private final byte[] creativeCode;


    private Map<String, byte[]> day1_cnt_features;
    // 3天内统计量
    private Map<String, byte[]> day3_cnt_features;
    // 7天内统计量
    private Map<String, byte[]> day7_cnt_features;
    // 3个月统计量
    private Map<String, byte[]> month3_cnt_features;


    public AdItemBytesFeature(AdItemFeature feature) {

        adId = feature.getAdId().getBytes();
        adCode = feature.getAdCode().getBytes();
        advertiserId = feature.getAdvertiserId().getBytes();
        advertiserCode = feature.getAdvertiserCode().getBytes();
        campaignId = feature.getCampaignId().getBytes();
        campaignCode = feature.getCampaignCode().getBytes();
        creative = feature.getCreative().getBytes();
        creativeCode = feature.getCreativeCode().getBytes();



        // 1 day statistic
        day1_cnt_features = new HashMap<String, byte[]>();
        day1_cnt_features.put("view", String.valueOf(feature.getDay1_cnt_features().getAdView()).getBytes());
        day1_cnt_features.put("click", String.valueOf(feature.getDay1_cnt_features().getAdClick()).getBytes());
        day1_cnt_features.put("conversion", String.valueOf(feature.getDay1_cnt_features().getAdConversion()).getBytes());
        day1_cnt_features.put("ctr", String.valueOf(feature.getDay1_cnt_features().getCtr()).getBytes());
        day1_cnt_features.put("cvr", String.valueOf(feature.getDay1_cnt_features().getCvr()).getBytes());


        // 3 day statistic
        day3_cnt_features = new HashMap<String, byte[]>();
        day3_cnt_features.put("view", String.valueOf(feature.getDay3_cnt_features().getAdView()).getBytes());
        day3_cnt_features.put("click", String.valueOf(feature.getDay3_cnt_features().getAdClick()).getBytes());
        day3_cnt_features.put("conversion", String.valueOf(feature.getDay3_cnt_features().getAdConversion()).getBytes());
        day3_cnt_features.put("ctr", String.valueOf(feature.getDay3_cnt_features().getCtr()).getBytes());
        day3_cnt_features.put("cvr", String.valueOf(feature.getDay3_cnt_features().getCvr()).getBytes());


        // 7 day statistic
        day7_cnt_features = new HashMap<String, byte[]>();
        day7_cnt_features.put("view", String.valueOf(feature.getDay7_cnt_features().getAdView()).getBytes());
        day7_cnt_features.put("click", String.valueOf(feature.getDay7_cnt_features().getAdClick()).getBytes());
        day7_cnt_features.put("conversion", String.valueOf(feature.getDay7_cnt_features().getAdConversion()).getBytes());
        day7_cnt_features.put("ctr", String.valueOf(feature.getDay7_cnt_features().getCtr()).getBytes());
        day7_cnt_features.put("cvr", String.valueOf(feature.getDay7_cnt_features().getCvr()).getBytes());


        // 3 month statisic
        month3_cnt_features = new HashMap<String, byte[]>();
        month3_cnt_features.put("view", String.valueOf(feature.getMonth3_cnt_features().getAdView()).getBytes());
        month3_cnt_features.put("click", String.valueOf(feature.getMonth3_cnt_features().getAdClick()).getBytes());
        month3_cnt_features.put("conversion", String.valueOf(feature.getMonth3_cnt_features().getAdConversion()).getBytes());
        month3_cnt_features.put("ctr", String.valueOf(feature.getMonth3_cnt_features().getCtr()).getBytes());
        month3_cnt_features.put("cvr", String.valueOf(feature.getMonth3_cnt_features().getCvr()).getBytes());

    }

}
