package com.tzld.piaoquan.ad.engine.commons.base;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import lombok.Getter;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotNull;

@Getter
@NoArgsConstructor
public class AdItemFeature {
    @NotNull
    private String adId;

    private String adCode;

    private String advertiserId;

    private String advertiserCode;

    private String campaignId;

    private String campaignCode;

    private String creative;

    private String creativeCode;


    // 当天统计量信息
    private AdActionFeature day1_cnt_features;
    // 3天内统计量
    private AdActionFeature day3_cnt_features;
    // 7天内统计量
    private AdActionFeature day7_cnt_features;
    // 3个月统计量
    private AdActionFeature month3_cnt_features;


    public void setAdvertiserId(String key){
        if(key == null){
            this.advertiserId = "0";
        } else {
            this.advertiserId = key;
        }
    }

    public void setDay1_cnt_features(AdActionFeature feature){
        this.day1_cnt_features = feature;
    }


    public void setDay3_cnt_features(AdActionFeature feature){
        this.day3_cnt_features = feature;

    }

    public void setDay7_cnt_features(AdActionFeature feature){
        this.day7_cnt_features = feature;

    }

    public void setMonth3_cnt_features(AdActionFeature feature){
        this.month3_cnt_features= feature;

    }

    public String getKey() {
        return this.adId;
    }

    public String getValue(){
        Gson gson = new GsonBuilder().serializeSpecialFloatingPointValues().create();
        return gson.toJson(this);
    }


}
