package com.tzld.piaoquan.ad.engine.commons.base;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import lombok.Getter;
import lombok.NoArgsConstructor;

@Getter
@NoArgsConstructor
public class UserAdFeature {
    private String mid;

    private String gender;
    private String user_type;
    private String gmt_create;
    private String tags;
    private String category_name;
    private String isvip;
    private String isreward;
    private String isad;
    private String isgood;

    private String first_up_datetime;
    private String last_up_datetime;
    private String next_to_last_up_datetime;
    private String videos; // 上传视频数量
    private String idols; // 关注人数
    private String fans;  // 粉丝数
    private String play_count;  // 播放人数
    private String play_count_total;  // 累计播放次数

    private String total_reward;
    private String currentday_reward;
    private String reward_person;
    private String total_reward_times;

    private String reward_videos;
    private String total_price;
    private String currentday_price;
    private String total_price_times;
    private String total_price_person;
    private String total_price_videos;
    private String cgrain_user_type;
    private String identity_tagname;


    private String operation_tags;
    private String identity_tag_id;
    private String identity_create_time;
    private String country;
    private String province;
    private String city;




    // 当天统计量信息
    private AdActionFeature day1_cnt_features;
    // 3天内统计量
    private AdActionFeature day3_cnt_features;
    // 7天内统计量
    private AdActionFeature day7_cnt_features;
    // 3个月统计量
    private AdActionFeature month3_cnt_features;




    public void setMid(String key){
        this.mid = key;
        if(key == null)
            this.mid = "0";
    }


    public void setDay1_cnt_features(AdActionFeature key){
        this.day1_cnt_features = key;
        if(key == null)
            this.day1_cnt_features = new AdActionFeature();
    }

    public void setDay3_cnt_features(AdActionFeature key){
        this.day3_cnt_features = key;
        if(key == null)
            this.day3_cnt_features = new AdActionFeature();
    }

    public void setDay7_cnt_features(AdActionFeature key){
        this.day7_cnt_features = key;
        if(key == null)
            this.day7_cnt_features = new AdActionFeature();
    }

    public void setMonth3_cnt_features(AdActionFeature key) {
        this.month3_cnt_features = key;
        if(key == null)
            this.month3_cnt_features = new AdActionFeature();
    }




    public String getKey() {
        return this.mid;
    }

    public String getValue(){
        Gson gson = new GsonBuilder().serializeSpecialFloatingPointValues().create();
        return gson.toJson(this);
    }

}
